//+------------------------------------------------------------------+
//|                                                      jbtest3.mq4 |
//|                                    Copyright  2009, Johan Brits |
//|                                       http://www.besharewise.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Johan Brits"
#property link      "http://www.besharewise.com"
// jbtest7
#define MAGICMA  20050610

extern double Lots               = 0.01;
extern double MaximumRisk        = 0.02;
extern double DecreaseFactor     = 3;
extern double ShortEma       = 5;
extern double LongEma        = 25;

extern bool EmailON        =true;
extern int TakeProfit = 800;
extern int StopLoss = 200;
extern int TrailingStop=50;
extern int TS.Min.Move.Pips = 1;
extern int Slippage = 5;

string strSymbol;

int Real.TakeProfit, Real.StopLoss, Real.Slippage, Real.TrailingStop, Real.TS.Min.Move.Pips;

//+------------------------------------------------------------------+
//| Supporting functions                                             |
//+------------------------------------------------------------------+

void MoveTSPerMNwithFullPip(int iMN, int iTS)
{
// Changed to not default a SL

int icnt, itotal;
double dTS, dMinMove, dActualMove;

dMinMove = (Point*iTS)+(Real.TS.Min.Move.Pips*Point);
dActualMove = (Point*iTS);

itotal=OrdersTotal();

   for(icnt=0;icnt<itotal;icnt++) 
     {                               // order loop boundary
      OrderSelect(icnt, SELECT_BY_POS, MODE_TRADES);
      
       // check for opened position, symbol & MagicNumber
      if(OrderType()==OP_SELL && OrderSymbol()==strSymbol  && OrderMagicNumber()==iMN)  
        {     
         if((OrderOpenPrice() - Ask) > (dActualMove))
          {         
           if((OrderStopLoss() - Ask) > dMinMove)  
              {
                dTS = NormalizeDouble(Ask+dActualMove, Digits);
                OrderModify(OrderTicket(),OrderOpenPrice(), dTS, OrderTakeProfit(),0,Yellow);
              }
          }
      }
        
        
       if(OrderType()==OP_BUY && OrderSymbol()==strSymbol  && OrderMagicNumber()==iMN)  
        {   
         if((Bid - OrderOpenPrice()) > dActualMove)
          {     
            if((Bid - OrderStopLoss()) > dMinMove)
              {
                dTS = NormalizeDouble(Bid-dActualMove, Digits);
                OrderModify(OrderTicket(),OrderOpenPrice(), dTS,OrderTakeProfit(),0,Green);
              }
          }
              
        }

     }  // order loop boundary

return(0);
     
}

//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
  int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
 double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      
      int Multiplying=1;
      
     if(losses>1) lot=NormalizeDouble(Lots*Multiplying*losses,1);
     }
//---- return lot size
   if(lot<Lots) lot=Lots;
   return(lot);
  }  
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
{
double Ema;
int res;
//---- go trading only for first tiks of new bar
if(Volume[0]>1) return;
//---- get Moving Average
Ema=iMA(NULL,0,ShortEma,LongEma,MODE_SMA,PRICE_CLOSE,0);
double SEMA1=iMA(NULL,0,ShortEma,0,MODE_SMA,PRICE_CLOSE,1);
double LEMA1=iMA(NULL,0,LongEma,0,MODE_SMA,PRICE_CLOSE,1);
double SEMA2=iMA(NULL,0,ShortEma,0,MODE_SMA,PRICE_CLOSE,2);
double LEMA2=iMA(NULL,0,LongEma,0,MODE_SMA,PRICE_CLOSE,2);

//---- sell conditions
// if(Open[1]>Ema && Close[1]<Ema)
if (SEMA1<LEMA1 && SEMA2>LEMA2)
{
 res=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,3,0,0,"My order comment",MAGICMA,0,Red);
 // send sell email
 //if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
 if (EmailON) SendMail(AccountNumber()+" SELL signal alert","SELL signal at Ask="+DoubleToStr(Ask,4)+", Bid="+DoubleToStr(Bid,4)+", Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
return;
}
//---- buy conditions
//  
if (SEMA1>LEMA1 && SEMA2<LEMA2)
{
res=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,0,0,"My order comment",MAGICMA,0,Blue);
// send buy email
//if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
 if (EmailON) SendMail(AccountNumber()+" BUY signal alert","BUY signal at Ask="+DoubleToStr(Ask,4)+", Bid="+DoubleToStr(Bid,4)+", Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
return;
}
//----
}

void CheckForClose()
{
double Ema;
//---- go trading only for first tiks of new bar
if(Volume[0]>1) return;
//---- get Moving Average
Ema=iMA(NULL,0,ShortEma,LongEma,MODE_SMA,PRICE_CLOSE,0);
double SEMA1=iMA(NULL,0,ShortEma,0,MODE_SMA,PRICE_CLOSE,1);
double LEMA1=iMA(NULL,0,LongEma,0,MODE_SMA,PRICE_CLOSE,1);
double SEMA2=iMA(NULL,0,ShortEma,0,MODE_SMA,PRICE_CLOSE,2);
double LEMA2=iMA(NULL,0,LongEma,0,MODE_SMA,PRICE_CLOSE,2);
//----
for(int i=0;i<OrdersTotal();i++)
{
if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;


//---- check order type
if(OrderType()==OP_BUY)
{
// if(Open[1]>Ema && Close[1]<Ema)
if (SEMA1<LEMA1 && SEMA2>LEMA2) OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
break;

}
if(OrderType()==OP_SELL)
{
// if(Open[1]<Ema && Close[1]>Ema)
if (SEMA1>LEMA1 && SEMA2<LEMA2) OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
break;
}
}

// trailing stop
  /* if(TrailingStop>0)
      {
      SelectOrder(MAGICMA,SELECT_BY_TICKET);
      {
     if(OrderStopLoss()<Bid-Point*TrailingStop)
     {*/
//----
}
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
int start()

  {
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol

// Call Trailing Stop check every tick
   if (TrailingStop!=0) MoveTSPerMNwithFullPip(MAGICMA, Real.TrailingStop); 
   
 CheckForOpen();
 CheckForClose();
 
//----


  }
 
//+------------------------------------------------------------------+